#!/usr/bin/python

#rozbiehanie programu
import pygame
import os
import platform
if platform.system() == 'Windows':
    os.environ['SDL_VIDEODRIVER'] = 'windib'
pygame.init()
from pygame import * #potrebne
from random import * #potrebne
import time #nie prilis potrebne
import numpy as np #potrebne
from collections import deque #potrebne, umoznuje fungovanie hada

#Toto je server pre hru
#Vsetky vypocty a overovanie koliziii budu prebiehat tu
#najprv sa musi hrac pripojit

#seed pre randint
try:
    seed(os.urandom(8192))
except:
    pass

velkost_bloku = 5 #vzdy bude menena len tu a hraci/admini to nebudu moct menit
#definicia pevnosti(typu) blokov
priechodne_bloky = [0,11,21,31,41,51,61,71,81,91,101]
hrabatelne_bloky = [1,2]
nehrabatelne_bloky = [3,4,10,20,30,40,50,60,70,80,90,100]
#domcekove bloky
zakladnove_bloky = [10,11,20,21,30,31,40,41,50,51,60,61,70,71,80,81,90,91,100,101]
#neznicitelne bloky
neznicitelne_bloky = [4]
#classy a funkcie
#drobna na funkcia na asistenciu pri zistovanii priechodnosti z typu blokov
def zisti_priechodnost_bloku(blok): #akoze ci je neznicitelny, znicitelny alebo priechodny
    #pre zatial to staci ale bude to potrebovat upravy ak pridam ine bloky
    if blok in neznicitelne_bloky:
        return 3
    if blok == 0:
        return 0
    if blok in hrabatelne_bloky:
        return 1
    if blok in nehrabatelne_bloky:
        return 2
#Neviem vymysliet dobry komentar
def zisti_priechodnost_blokov(zoznam_blokov):
    stav_volnosti = 0
    for i in zoznam_blokov:
        if zisti_priechodnost_bloku(i) == 1 and stav_volnosti != 2 and stav_volnosti != 3:
            stav_volnosti = 1
        if zisti_priechodnost_bloku(i) == 2 and stav_volnosti != 3:
            stav_volnosti = 2
        if zisti_priechodnost_bloku(i) == 3:
            stav_volnosti = 3
    return stav_volnosti

#Class pre strelu
class Strela():
    x = 0
    y = 0
    otocenie = 0
    otocenie_na_pohyb = {0:[0,-1],1:[1,-1],2:[1,0],3:[1,1],4:[0,1],5:[-1,1],6:[-1,0],7:[-1,-1]}
    typ = ""

    utok = 20 #Kolko stitov uberie na jeden zasah

    nova = True 

    def __init__(self,x,y,otocenie,utok,typ):
        self.x = x
        self.y = y
        self.otocenie = otocenie

        self.x += self.otocenie_na_pohyb[self.otocenie][0]*velkost_bloku*3 #Tato 3 sa moze zmenit ak sa zmeni velkost hraca (Co sa asi nestane)
        self.y += self.otocenie_na_pohyb[self.otocenie][1]*velkost_bloku*3

        self.utok += utok
        self.typ = typ
        
    def pohyb(self):
        if "vymazana" in self.typ:
            return ""
        self.x += self.otocenie_na_pohyb[self.otocenie][0]*velkost_bloku
        self.y += self.otocenie_na_pohyb[self.otocenie][1]*velkost_bloku

        #Zisti ci strela nenarazila do dakeho bloku
        if not mapa[self.x/velkost_bloku][self.y/velkost_bloku] in priechodne_bloky:
            self.typ += "vymazana"
            if mapa[self.x/velkost_bloku][self.y/velkost_bloku] in hrabatelne_bloky and not "explozivna" in self.typ:
                return (str(self.x/velkost_bloku)+" "+str(self.y/velkost_bloku)+" "+"0"+":")
            elif not "explozivna" in self.typ:
                return ""
        #Zisti ci strela nenarazila do hraca
        for i in hraci:
            if self.x >= i.x and self.x <= i.x + i.velkost:
                if self.y >= i.y and self.y <= i.y + i.velkost and not self.nova and (i.faza == 0 or "EMP" in self.typ): 
                    i.stity -= self.utok
                    if "EMP" in self.typ:
                        i.energia -= 25 #EMP strely uberaju energiu
                    self.typ += "vymazana"
        #vybuch explozivnej strely
        if "explozivna" in self.typ and "vymazana" in self.typ:
            r = 5*velkost_bloku
            r2 = r**2
            x1 = self.x + velkost_bloku/2
            y1 = self.y + velkost_bloku/2 #stred vybuchu

            #drobne premenne na znizenie zataze procesora
            x1_r_velkost_bloku = (x1-r)/velkost_bloku #(x1-r)/velkost_bloku = jednoduche ulozenie vysledku do premnnej
            y1_r_velkost_bloku = (y1-r)/velkost_bloku #(y1-r)/velkost_bloku = to iste co riadok vyssie len s Y

            #nicenie blokov
            zmenene_bloky = ""
            for i in xrange(r*2/velkost_bloku):
                i_velkost_bloku = i*velkost_bloku #Dalsi krok na znizenie zataze = Ulozenie i*velkost_bloku do premennej
                for j in xrange(r*2/velkost_bloku):
                    j_velkost_bloku = j*velkost_bloku #Dalsi krok na znizenie zataze = Ulozenie j*velkost_bloku do premennej
                    try: 
                        if not ((mapa[x1_r_velkost_bloku+i][y1_r_velkost_bloku+j] == 0) or x1_r_velkost_bloku+i < 0
                                or y1_r_velkost_bloku+j < 0):
                            if (((-r+i_velkost_bloku)**2)+((-r+j_velkost_bloku)**2)) <= r2:
                                if mapa[x1_r_velkost_bloku+i][y1_r_velkost_bloku+j] in [1,2,3]:
                                    zmenene_bloky += str(x1_r_velkost_bloku+i) + " " + str(y1_r_velkost_bloku+j) + " 0:"
                    except IndexError:
                        pass

            for i in hraci: #Poskod vsetkych hracov v dosahu vybuchu
                if (((x1-(i.x+i.velkost/2))**2 + (y1-(i.y+i.velkost/2))**2) <= r2) and (i.faza == 0 or "EMP" in self.typ):
                    i.stity -= self.utok
                    if "EMP" in self.typ:
                        i.energia -= 25 #EMP strely uberaju energiu

            return zmenene_bloky
        
        
        self.nova = False
        return ""
        
#Premenne
nevypisuj_kto_vyhral = False

#class pre Hraca - uskladnuje vsetky informacie o nom + jeho socket
class Hrac():
    #X a Y - laveho horneho rohu hraca
    #Lavy horny roh = 0 0, Pravy dolny roh = ? ?
    x = 0
    y = 0
    #pociatocne x a y
    pociatocne_x = 0
    pociatocne_y = 0
    #velkost tanku/hraca
    velkost = 7*velkost_bloku #7 blokov
    #Co si hrac praje urobit
    prikazy = []
    #hracov socket
    pripojenie = 0
    #smer/otocenie hraca (0-7){vratane} - smer hodinove rucicky
    otocenie = 0
    otocenie_podla_prikazu = {"vlavo":6,"vlavohore":7,"vlavodole":5,"hore":0,"vpravohore":1,"vpravo":2,"vpravodole":3,"dole":4}
    #prepocet smeru/otocenia na pohyb
    otocenie_na_pohyb = {0:[0,-1],1:[1,-1],2:[1,0],3:[1,1],4:[0,1],5:[-1,1],6:[-1,0],7:[-1,-1]}

    #Energia a stity
    energia = 300 #Maximum bude 300
    stity = 200 #Minaju sa ked je hrac zasiahnuty
    max_energia = 300
    max_stity = 200

    #farba hraca
    farba = ""

    #nabijanie
    nabite = 0 #Striela sa ak je nabite vacsie ako 2

    #Ma antihmotu na sebe?
    nesie_antihmotu = False
    
    #system pre vylepsenia (hrac zbiera "diamanty" a kupuje si vylepsenia)
    peniaze = 0 #kolko ma hrac "penazi/diamantov..." - nazvem to peniaze lebo sa to lahko pamata
    eu = 0 #Energeticka uspornost - spotrebovana energia sa bude pocitat x * (1 - eu)
    strana_obchodu = "" #Nech hrac moze vyberat z viac nez styroch vylepseni
    vylepsenia_max = [19,9,6,10,1,1,1,1] #Kolko vylepseni jedneho typu sa da naraz mat
    vylepsenia_level = [] #Kolko vylepseni ktoreho typu hrac uz ma
    utok = 0 #Bonus k utoku striel
    rychlopalba = "" #Ak si hrac kupi rychlo palbu, bude strielat kazdy frame
    typ_utoku = 0 #Typ vystrelenej strely, zatial obycajna, EMP, explozivna
    #Zatial su e. uspornost, max stity, baterie, utok, rychlopalba, emp strely, vybusne strely

    #Nove - transdimenzionalny fazovy menic
    faza = 0 #V faze 0, je normalny svet. Vo faze 1 je hrac skoro nezranitelny (len EMP a antihmota mu ublizia)
    fazovac = False #Ci ma hrac kupeny fazovac


    #pri vzniku
    def __init__(self,pripojenie):
        self.pripojenie = pripojenie
        self.vylepsenia_level = [0,0,0,0,0,0,0,0]
        self.strana_obchodu = 0
        self.rychlopalba = False
        self.typ_utoku = "obycajna"
        
    #funkcie na spracovanie prikazov od hraca
    def spracuj_prikazy(self,prikazy): #nakoniec to teda bude univerzalna funkcia ktora hraca aj posluchne aj zisti ako s nim interaguju bloky
        #pomocne premenne
        vrchny_blok_x = self.x/velkost_bloku-1
        vrchny_blok_y = self.y/velkost_bloku-1
        #hracova velkost preratana na bloky
        velkost = self.velkost/velkost_bloku
        
        global zmena_antihmoty

        
        #Zisti sa ci je hrac v domceku a komu patri ten domcek
        je_hrac_v_zakladni = 0 #0 = nie je, 1 = je v cudzej, 2 = je vo svojej
        hrac_nie_je_zakladni = False
        for i in xrange(velkost):
            for j in xrange(velkost):
                if mapa[vrchny_blok_x + i+1][vrchny_blok_y + j+1] == farby_hracov_na_ich_cisla[self.farba]*10+1:
                    je_hrac_v_zakladni = 2
                elif mapa[vrchny_blok_x + i+1][vrchny_blok_y + j+1] in zakladnove_bloky:
                    je_hrac_v_zakladni = 1
                else:
                    hrac_nie_je_zakladni = True

        #doplnanie energie a stitov
        if je_hrac_v_zakladni == 1 and hrac_nie_je_zakladni == False and self.faza == 0:
            if self.energia < self.max_energia:
                self.energia += 3
        if je_hrac_v_zakladni == 2 and hrac_nie_je_zakladni == False and self.faza == 0:
            if self.energia < self.max_energia:
                self.energia += 3
            if self.stity < self.max_stity:
                self.stity += 1
        
        if self.energia > self.max_energia:
            self.energia = self.max_energia
                    
        #Zisti ci hrac sa nedotyka antihmoty a ak ano, tak nech ju zoberie
        tmp = Rect(self.x,self.y,self.velkost,self.velkost)
        if not self.nesie_antihmotu:
            for i in zoznam_antihmoty:
                if tmp.colliderect(i.stvorec) and i.nesena == False and not i.stabilita == 1 and self.faza == 0: #to so stabilitou, nech nemoze hrac zobrat vybuchujucu antihmotu
                    self.nesie_antihmotu = True
                    i.nesena = True #oznami antihmote ze je presuvana
                    break

        #Ak hrac nesie antihmotu, konstantne mu odobera energiu
        if self.nesie_antihmotu:
            self.energia -= 0.1
        
        self.nabite += 1
        if prikazy == ['']:
            return ""

        #zisti ci hrac nezobral diamant
        tmp = Rect(self.x,self.y,self.velkost,self.velkost)
        for i in zoznam_diamantov:
            if tmp.colliderect(i.stvorec) and self.faza == 0:
                self.peniaze += 10 #Tu sa meni kolko penazi dostane hrac za diamant
                i.zmaz_sa = True
                break
        
        #prikazy vzdy pridu v poradii smer/otocenie:strelba:specialne
        #zmenene bloky vratene funkciou hrab
        if not prikazy[0] == "nic":
            zmenene_bloky = self.otocsa(prikazy[0])
        else:
            zmenene_bloky = ""

        if zmenene_bloky != "" and prikazy[1] == "vystrel":
            self.energia -= 1*(1-self.eu)
            self.pohyb()

        #strielanie
        elif prikazy[1] == "vystrel":
            self.vystrel()

        #Pokladanie antihmoty
        if prikazy[2] == "poloz" and self.nesie_antihmotu and self.faza == 0:
            volno = True
            try:
                for i in xrange(3):
                    for j in xrange(2):
                        if not mapa[(self.x+10)/velkost_bloku+i][(self.y+self.velkost)/velkost_bloku+j] in priechodne_bloky:
                            volno = False
            except IndexError:
                volno = False
            if volno:
                self.nesie_antihmotu = False
                zoznam_antihmoty.append(Antihmota(self.x+10,self.y+self.velkost,100))
                zmena_antihmoty = True

        #fazovanie
        if prikazy[2] == "fazuj" and self.fazovac:
            self.faza = abs(self.faza-1)

        #Vylepsenia - ich nakup
        if not ("-1" in prikazy[3] or prikazy[3] == "" or prikazy[3] == " " or prikazy[3] == "5"):
            tmp = self.strana_obchodu * 4 #Posun sa v zoznamoch vylepseni o styri dalej ak je strana 1.
            try:
                if (self.peniaze >= vylepsenia_ceny[int(prikazy[3])-1+tmp] and self.vylepsenia_max[int(prikazy[3])-1+tmp]
                > self.vylepsenia_level[int(prikazy[3])-1+tmp]):
                    self.peniaze -= vylepsenia_ceny[int(prikazy[3])-1+tmp]
                    self.vylepsenia_level[int(prikazy[3])-1+tmp] += 1
                    if prikazy[3] == "1":
                        if self.strana_obchodu == 0:
                            self.eu += 0.05 #Zvys energeticku uspornost
                        if self.strana_obchodu == 1:
                            self.rychlopalba = True #Zrychli strelbu
                    if prikazy[3] == "2":
                        if self.strana_obchodu == 0:
                            self.max_stity += 40 #Zvys maximalne stity
                        if self.strana_obchodu == 1:
                            self.typ_utoku += "EMP" #Umozni strielat EMP strely
                    if prikazy[3] == "3":
                        if self.strana_obchodu == 0:
                            self.max_energia += 40 #Zvys max mnoznstvo energie
                        if self.strana_obchodu == 1:
                            self.typ_utoku += "explozivna" #Umozni strielat explozivne strely
                    if prikazy[3] == "4":
                        if self.strana_obchodu == 0:
                            self.utok += 5 #Zvysi mnozstvo ubratych stitov pri zasiahnuti inych hracov
                        if self.strana_obchodu == 1:
                            self.fazovac = True
            except IndexError:
                pass
        if prikazy[3] == "5":
            self.strana_obchodu = 1-self.strana_obchodu #Zmeni z 0 na 1 a z 1 na 0
        if not zmenene_bloky == None:
            return zmenene_bloky

    #strielanie
    def vystrel(self):
        if (self.nabite >= 3 or (self.rychlopalba and self.nabite >= 2)) and self.faza == 0: #hraci nemozu strielat ak su v inej faze
            self.nabite = 0
            self.energia -= 1*(1-self.eu)
            #vytvori strelu - argumenty = x,y,otocenie
            zoznam_striel.append(Strela((self.x+self.velkost/2-velkost_bloku/2),(self.y+self.velkost/2-velkost_bloku/2),(self.otocenie),self.utok,self.typ_utoku))
        

        
    #pohyb a otocenie
    def otocsa(self,prikaz):
        self.otocenie = self.otocenie_podla_prikazu[prikaz]
        return self.zisti_volnost()
    def pohyb(self): #pohyb a detekcia kolizie s hracmi
        volno = True
        self.x += self.otocenie_na_pohyb[self.otocenie][0]*velkost_bloku
        self.y += self.otocenie_na_pohyb[self.otocenie][1]*velkost_bloku
        for i in hraci:
            if not i == self:
                tmp_1 = Rect(self.x,self.y,self.velkost,self.velkost)
                tmp_2 = Rect(i.x,i.y,i.velkost,i.velkost)
                if tmp_1.colliderect(tmp_2):
                    volno = False
        if volno == False and not self.faza == 1:
            self.x -= self.otocenie_na_pohyb[self.otocenie][0]*velkost_bloku
            self.y -= self.otocenie_na_pohyb[self.otocenie][1]*velkost_bloku
        
    #hrabanie
    def hrab(self):
        vrchny_blok_x = self.x/velkost_bloku-1
        vrchny_blok_y = self.y/velkost_bloku-1

        #hracova velkost preratana na bloky
        velkost = self.velkost/velkost_bloku

        #zmenene bloky
        zmenene_bloky = ""
            
        if self.otocenie == 0 or self.otocenie == 1 or self.otocenie == 7:
            for i in xrange(velkost+2):
                if mapa[vrchny_blok_x+i][vrchny_blok_y] in hrabatelne_bloky:
                    zmenene_bloky += str(str(vrchny_blok_x+i)+" "+str(vrchny_blok_y)+" "+str(0)+":")
                    
        if self.otocenie == 2 or self.otocenie == 1 or self.otocenie == 3:
            for i in xrange(velkost+2):
                if mapa[vrchny_blok_x+1+velkost][vrchny_blok_y+i] in hrabatelne_bloky:
                    zmenene_bloky += str(str(vrchny_blok_x+1+velkost)+" "+str(vrchny_blok_y+i)+" "+str(0)+":")
                    
        if self.otocenie == 4 or self.otocenie == 3 or self.otocenie == 5:
            for i in xrange(velkost+2):
                if mapa[vrchny_blok_x+i][vrchny_blok_y+1+velkost] in hrabatelne_bloky:
                    zmenene_bloky += str(str(vrchny_blok_x+i)+" "+str(vrchny_blok_y+1+velkost)+" "+str(0)+":")
                    
        if self.otocenie == 6 or self.otocenie == 5 or self.otocenie == 7:
            for i in xrange(velkost+2):
                if mapa[vrchny_blok_x][vrchny_blok_y+i] in hrabatelne_bloky:
                    zmenene_bloky += str(str(vrchny_blok_x)+" "+str(vrchny_blok_y+i)+" "+str(0)+":")

        return zmenene_bloky
                
    #detekcia kolizie s blokmi
    def zisti_volnost(self):
        vrchny_blok_x = self.x/velkost_bloku-1
        vrchny_blok_y = self.y/velkost_bloku-1
        stav_volnosti = 0 #znamena 0 = volno, 1 = Hrabatelne, 2 = Nehrabatelne
        #hracova velkost preratana na bloky
        velkost = self.velkost/velkost_bloku
        #docasny zoznam na overovanie
        docasny_zoznam = []
        #teraz to samotne zistovanie
        #treba urobit pre vsetkych 8 smerov :(
        if self.otocenie == 0:
            for i in mapa[vrchny_blok_x+1:vrchny_blok_x+velkost+1]:
                docasny_zoznam.append(i[vrchny_blok_y])
        if self.otocenie == 1:
            for i in mapa[vrchny_blok_x+2:vrchny_blok_x+velkost+2]:
                docasny_zoznam.append(i[vrchny_blok_y])
            for i in mapa[vrchny_blok_x+velkost+1][vrchny_blok_y:vrchny_blok_y+velkost]:
                docasny_zoznam.append(i)
        if self.otocenie == 2:
            for i in mapa[vrchny_blok_x+velkost+1][vrchny_blok_y+1:vrchny_blok_y+velkost+1]:
                docasny_zoznam.append(i)
        if self.otocenie == 3:
            for i in mapa[vrchny_blok_x+2:vrchny_blok_x+velkost+2]:
                docasny_zoznam.append(i[vrchny_blok_y+velkost+1])
            for i in mapa[vrchny_blok_x+velkost+1][vrchny_blok_y+2:vrchny_blok_y+velkost+1]:
                docasny_zoznam.append(i)
        if self.otocenie == 4:
            for i in mapa[vrchny_blok_x+1:vrchny_blok_x+velkost+1]:
                docasny_zoznam.append(i[vrchny_blok_y+velkost+1])
        if self.otocenie == 5:
            for i in mapa[vrchny_blok_x:vrchny_blok_x+velkost-1]:
                docasny_zoznam.append(i[vrchny_blok_y+velkost+1])
            for i in mapa[vrchny_blok_x][vrchny_blok_y+2:vrchny_blok_y+velkost+2]:
                docasny_zoznam.append(i)
        if self.otocenie == 6:
            for i in mapa[vrchny_blok_x][vrchny_blok_y+1:vrchny_blok_y+velkost+1]:
                docasny_zoznam.append(i)
        if self.otocenie == 7:
            for i in mapa[vrchny_blok_x:vrchny_blok_x+velkost]:
                docasny_zoznam.append(i[vrchny_blok_y])
            for i in mapa[vrchny_blok_x][vrchny_blok_y:vrchny_blok_y+velkost]:
                docasny_zoznam.append(i)
            
        #konecne overenie
        if zisti_priechodnost_blokov(docasny_zoznam) == 1 and self.faza == 0:
            #spotrebuj energiu
            self.energia -= 0.3*(1-self.eu)
            return self.hrab()
        elif zisti_priechodnost_blokov(docasny_zoznam) == 0 or (self.faza == 1 and not zisti_priechodnost_blokov(docasny_zoznam) == 3):
            #spotrebuj energiu
            self.energia -= 0.1*(1-self.eu)
            self.pohyb()
        return ""

class Antihmota(): #vybusnina
    stvorec = 0

    #premenne o jej stave
    nesena = False #Ak ju hrac nesie alebo sa ma znicit, tak True - Antihmota sa potom vymaze, kvoli tomu ze sa stane "sucastou" hraca alebo bude inak odstranena
    stabilita = -1 #Ak ju hrac nenesie a nema zdroj energie, odpocitava sa a pri nule vybuchne
    #V pripade zapornych cisel, je permanentne stabilna (Normalne ma byt nestabilna alebo sa drzat nad nulou)
    vybuch = False
    vybuchuje = False #potrebne na to nech antihmota nevybuchuje do nekonecna

    def __init__(self,x,y,stabilita = 100):
        self.stvorec = Rect(x,y,3*5,2*5)
        self.stabilita = stabilita

    def over_sa(self): #zisti sa ci je antihmota stabilna, ak nie vybuchne
        stabilizovana = True #V pripade ze je antihmota v zakladni, je uplne stabilna
        for i in xrange(3):
            for j in xrange(2):
                if not (mapa[(self.stvorec.x)/velkost_bloku+i][(self.stvorec.y)/velkost_bloku+j] in priechodne_bloky
                        and mapa[(self.stvorec.x)/velkost_bloku+i][(self.stvorec.y)/velkost_bloku+j] in zakladnove_bloky):
                    stabilizovana = False
        if (not stabilizovana or self.stabilita == 1): #Ak antihmota nie je v zakladni, destabilizuje sa
            self.stabilita -= 1
        if self.stabilita == 0: #Ked je stabilna na 0%, vybuchne
            self.vybuch = True

        if self.stabilita == -10 and self.vybuch: #odstranenie vybuchnutej antihmoty
            self.vybuch = False
            self.nesena = True

    def exploduj(self): #Znici bloky v polomere 250 pixelov a hracov tiez
        self.vybuchuje = True
        r = 50*velkost_bloku #r ako polomer
        r2 = r**2 #r na druhu, potrebne pre zistenie ci je objekt vnutri vybuchu
        x1 = self.stvorec.centerx
        y1 = self.stvorec.centery #stred vybuchu

        #drobne premenne na znizenie zataze procesora
        x1_r_velkost_bloku = (x1-r)/velkost_bloku #(x1-r)/velkost_bloku = jednoduche ulozenie vysledku do premnnej
        y1_r_velkost_bloku = (y1-r)/velkost_bloku #(y1-r)/velkost_bloku = to iste co riadok vyssie len s Y

        #nicenie blokov
        zmenene_bloky = ""
        for i in xrange(r*2/velkost_bloku):
            i_velkost_bloku = i*velkost_bloku #Dalsi krok na znizenie zataze = Ulozenie i*velkost_bloku do premennej
            for j in xrange(r*2/velkost_bloku):
                j_velkost_bloku = j*velkost_bloku #Dalsi krok na znizenie zataze = Ulozenie j*velkost_bloku do premennej
                try:
                    if not ((mapa[x1_r_velkost_bloku+i][y1_r_velkost_bloku+j] == 0) or x1_r_velkost_bloku+i < 0
                            or y1_r_velkost_bloku+j < 0):
                        if (((-r+i_velkost_bloku)**2)+((-r+j_velkost_bloku)**2)) <= r2:
                            if not mapa[x1_r_velkost_bloku+i][y1_r_velkost_bloku+j] in neznicitelne_bloky:
                                zmenene_bloky += str(x1_r_velkost_bloku+i) + " " + str(y1_r_velkost_bloku+j) + " 0:"
                except IndexError:
                    pass

        for i in hraci: #Znic vsetkych hracov v dosahu vybuchu
            if ((x1-(i.x+i.velkost/2))**2 + (y1-(i.y+i.velkost/2))**2) <= r2:
                i.stity -= 539
                if i.nesie_antihmotu: #Ak nesu antihmotu, poloz ju na zem
                    i.nesie_antihmotu = False
                    zoznam_antihmoty.append(Antihmota(i.x+i.velkost/2,i.y+i.velkost/2))

        for i in zoznam_diamantov: #Znic diamanty v dosahu vybuchu
            if ((x1-(i.stvorec.centerx))**2 + (y1-(i.stvorec.centery))**2) <= r2:
                i.zmaz_sa = True

        
        for i in zoznam_antihmoty: #Odpal vsetku antihmotu v okoli
            if not i.vybuchuje and ((x1-i.stvorec.centerx)**2 + (y1-i.stvorec.centery)**2) <= r2:
                i.stabilita = 1

        return zmenene_bloky
                
class Diamant():
    stvorec = 0 #pygame.Rect premenna
    zmaz_sa = False  #Nech ine funkcie mozu povedat ci sa ma zmazat

    def __init__(self,x,y):
        self.stvorec = Rect(x,y,velkost_bloku*2,velkost_bloku*4)

class Snake():
    cislo_na_pohyb = {1:[0,1],2:[1,0],3:[0,-1],4:[-1,0]}
    def __init__(self,x,y,telo=[]):
        self.casti_tela = deque(telo)
        if telo == []:
            for i in range(3):
                self.casti_tela.append([x-i,y])

        self.predlz_sa = 0 #O kolko sa ma had predlzit (Vyuziva sa pri zbierani diamantov)
        self.zmaz_sa = False

    def hyb_sa(self):
        zmaz_posledny_diel = True
        #smer = randint(1,4)
        pokusov = 0

        #hladanie diamantov
        najblizsie = 10000000000
        najblizsi = 0
        try:
            for i in zoznam_diamantov:
                if ((self.casti_tela[0][0]*5-(i.stvorec.centerx))**2 + (self.casti_tela[0][1]*5-(i.stvorec.centery))**2) < najblizsie:
                    najblizsie = ((self.casti_tela[0][0]*5-(i.stvorec.centerx))**2 + (self.casti_tela[0][1]*5-(i.stvorec.centery))**2)

            for i in zoznam_diamantov:
                if ((self.casti_tela[0][0]*5-(i.stvorec.centerx))**2 + (self.casti_tela[0][1]*5-(i.stvorec.centery))**2) == najblizsie:
                    najblizsi = i
                    break

            x_co_treba_prejst = najblizsi.stvorec.centerx/5 - self.casti_tela[0][0]
            y_co_treba_prejst = najblizsi.stvorec.centery/5 - self.casti_tela[0][1]

            if abs(x_co_treba_prejst) > abs(y_co_treba_prejst):
                if x_co_treba_prejst == abs(x_co_treba_prejst):
                    smer = 2
                else:
                    smer = 4
            else:
                if y_co_treba_prejst == abs(y_co_treba_prejst):
                    smer = 1
                else:
                    smer = 3
        except IndexError:
            pass
        except AttributeError:
            self.zmaz_sa = True
            return ""
        #ak nie su diamanty alebo je daky iny problem
        try:
            if smer == 10:
                pass
        except NameError:
            smer = randint(1,4)
        #overenie ci je volne miesto v predu
        try:
            while not mapa[self.casti_tela[0][0]+self.cislo_na_pohyb[smer][0]][self.casti_tela[0][1]+self.cislo_na_pohyb[smer][1]] in [0,1,2]:
                smer += 1
                if smer == 5:
                    smer = 1
                #nech sa hra nezasekne ak had nenajde miesto na pohyb
                pokusov += 1
                if pokusov == 8:
                    self.zmaz_sa = True #had sa umrie ak je zaseknuty
                    return ""
        except IndexError:
            return ""
            
        #pohyb samotny
        self.casti_tela.appendleft([self.casti_tela[0][0]+self.cislo_na_pohyb[smer][0],self.casti_tela[0][1]+self.cislo_na_pohyb[smer][1]])
        if self.predlz_sa == 0:
            tmp = self.casti_tela.pop()
        else:
            self.predlz_sa -= 1
            zmaz_posledny_diel = False

        #zbieranie diamantov
        for i in zoznam_diamantov:
            if i.stvorec.collidepoint(self.casti_tela[0][0]*5,self.casti_tela[0][1]*5):
                i.zmaz_sa = True
                self.predlz_sa += 1
        
        #vykreslenie do sveta
        zmenene_bloky = ""
        for i in self.casti_tela:
            zmenene_bloky += str(i[0]) + " " + str(i[1]) + " 200:"
        if zmaz_posledny_diel:
            zmenene_bloky += str(tmp[0]) + " " + str(tmp[1]) + " 0:"

        return zmenene_bloky
    def rozmnoz_sa(self):
        if len(self.casti_tela) > 10:
            v = Snake(0,0,list(self.casti_tela)[5:])
            self.casti_tela = deque(list(self.casti_tela)[:5])
            return v
        else:
            return ""
        

#funkcia na upravovanie mapy podla prikazu(stringu)
def uprav_mapu(prikazy):
    if prikazy == "":
        return
    u_prikazy = [] #upravene prikazy
    u_prikazy = prikazy.split(":") #univerzalny oddelovac veci v sprave
    tmp = []
    for i in u_prikazy:
        tmp = i.split()
        if not tmp == []:
            try:
                if not (int(tmp[0]) < 0 or int(tmp[1]) < 0):
                    mapa[int(tmp[0])][int(tmp[1])] = int(tmp[2])
            except IndexError:
                pass

#funkcia na vytvorenie zakladne + predloha zakladne (Otocena o 90 stupnov) - zakladna je priblizne stvorec
predloha_zakladne = []
tmp = []
for i in xrange(39):
    tmp.append(3)
for i in xrange(7): #vyclenenie priestoru pred zakladnou, nech sa da odtial dostat
    predloha_zakladne.append(tmp)
predloha_zakladne.append([1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]) #vrchna strana
for i in xrange(len(predloha_zakladne[0])): #prida sa vnutro
    predloha_zakladne.append([1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1]) 

predloha_zakladne.append([1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]) #spodna strana
for i in xrange(7): #vyclenenie priestoru pred zakladnou, nech sa da odtial dostat
    predloha_zakladne.append(tmp)


def vytvor_zakladnu(x,y,ktoremu_hracovi_patria):  #x,y ako miesto v mape nie ako realne suradnice      
    khp = ktoremu_hracovi_patria #zaujimave je cislo hraca
    zmenene_bloky = ""
    for i in xrange(len(predloha_zakladne)):
        for j in xrange(len(predloha_zakladne[i])):
            if predloha_zakladne[i][j] == 0:
                zmenene_bloky += str(i+x)+" "+str(j+y)+" "+str(0)+":"
            elif predloha_zakladne[i][j] == 3:
                zmenene_bloky += str(i+x)+" "+str(j+y)+" "+str(randint(1,2))+":"
            else:
                zmenene_bloky += str(i+x)+" "+str(j+y)+" "+str(khp*10-1+predloha_zakladne[i][j])+":"

    return zmenene_bloky

#funkcia na vytvorenie kamena
nahodne_cislo_na_smer ={0:[0,-1],1:[1,0],2:[0,1],3:[-1,0]}
def vygeneruj_kamen(p_x,p_y,velkost = 100):
    zmenene_bloky = ""
    x = p_x
    y = p_y
    tmp = 0
    cas = 0
    for i in xrange(velkost):
        while (str(x)+" "+str(y)+" "+str(3)+":") in zmenene_bloky and cas < 10:
            tmp = randint(0,3) #vyber kde bude dalsi kusok kamena
            x += nahodne_cislo_na_smer[tmp][0]
            y += nahodne_cislo_na_smer[tmp][1]
            cas += 1
        cas = 0
        zmenene_bloky += str(x)+" "+str(y)+" "+str(3)+":"
        if randint(0,5) == 4:
            x = p_x
            y = p_y

    return zmenene_bloky

#dokonci kamene = presnejsie ich vyplni a zagulati
def dokonci_kamene():
    zmenene_bloky = ""
    susedia = 0 #kolko zo susedov bloku su kamene
    for i in xrange(1,len(mapa)-1):
        for j in xrange(1,len(mapa[i])-1):
            if mapa[i][j] == 1 or mapa[i][j] == 2:
                if mapa[i+1][j] == 3:
                    susedia += 1
                if mapa[i][j+1] == 3:
                    susedia += 1
                if mapa[i-1][j] == 3:
                    susedia += 1
                if mapa[i][j-1] == 3:
                    susedia += 1
                if susedia >= 3:
                    zmenene_bloky += str(i) + " " + str(j) + " " + str(3)+":"
                
            if mapa[i][j] == 3:
                if mapa[i+1][j] == 3:
                    susedia += 1
                if mapa[i][j+1] == 3:
                    susedia += 1
                if mapa[i-1][j] == 3:
                    susedia += 1
                if mapa[i][j-1] == 3:
                    susedia += 1
                if susedia < 2:
                    zmenene_bloky += str(i) + " " + str(j) + " " + str(randint(1,2))+":"    
            susedia = 0

    return zmenene_bloky

#Generovanie mapy - plnej hliny. Mapa bude array - velmi dolezite vediet, vyzadaju Numpy
def generuj_prazdnu_mapu(velkost_mapy_funkcia):
    tmp_mapa = np.ones((velkost_mapy_funkcia,velkost_mapy_funkcia),int)
    for i in xrange(velkost_mapy_funkcia):
        tmp_mapa[i][0] = 4
        tmp_mapa[0][i] = 4
        tmp_mapa[i][velkost_mapy_funkcia-1] = 4
        tmp_mapa[velkost_mapy_funkcia-1][i] = 4
    return tmp_mapa



#importnutie mojich vlastnych kniznic
from sietova_kniznica import *

#importnutie kniznice socket(stara sa o prijimanie a posielanie sprav)
import socket

#vytvorenie socketu na pripajanie hracov a na hru
herny_s = socket.socket() #herny_s = herny socket, potrebny na pocuvanie prikazov od hracov
host = socket.gethostname()
ipcka_hosta = socket.gethostbyname(host)
port = 8192
herny_s.setsockopt(socket.SOL_SOCKET,socket.SO_REUSEADDR,1)

#experimentalne na zrychlenie posielania a prijimania sprav
herny_s.setsockopt(socket.IPPROTO_TCP, socket.TCP_NODELAY, 1)


#Zoznam pripojeni a IP adries
pripojenia = []
adresy = []

#Debug mode - docasna vec, umoznuje rychle spustanie bez konfigurovania
debug_mode = False
#specialne nastavania - premenna
specialne_nastavenia = 8192
#pociatocne hodnoty - budu zmenene, v pripade vyuzitia debug modu sa hra nastavuje tu
pocet_hracov = 1
velkost_mapy = 100 #jednej strany - mapa je stvorec velkost_mapy * velkost_mapy
mnozstvo_kamenov = 0
pomer_antihmoty_ku_blokom = 100 #1 ku x**2 blokov
pomer_diamantov_ku_blokom = 5 #1 ku x**2 blokov
#Ma byt v hre aj had?
chcem_hada = False

#premenna pre vstup
vstup = ""
#vstup na nastavenie
if not debug_mode:
    vstup = raw_input("Zadaj pocet hracov (2 az 10): ")
    while True:
        try:
            pocet_hracov = int(vstup)
            if (pocet_hracov > 1 and pocet_hracov < 11) or specialne_nastavenia:
                print("Pocet hracov bol uspesne nastaveny \n")
                break
            elif pocet_hracov == 8192: 
                print("Specialne nastavenia boli povolene")
                specialne_nastavenia = True #Umoznuje zacat hru s primalo hracmi alebo primalou mapou...
                mnozstvo_kamenov = int(raw_input("Zadaj pozadovane mnostvo kamenov: "))
        except ValueError:
            pass
        if not specialne_nastavenia:
            print "Zadal si nespravnu hodnotu, musis zadat cele cislo z mnoziny <2,10>"
        vstup = raw_input("Zadaj pocet hracov znovu (2 az 10): ")

    vstup = raw_input("Zadaj dlzku strany mapy (400-4000): ")
    while True:
        try:
            velkost_mapy = int(vstup)
            if (velkost_mapy > 399 and velkost_mapy < 4001) or specialne_nastavenia:
                print "Dlzka strany mapy bola uspesne nastavena \n"
                break
        except ValueError:
            pass
        print "Zadal si nespravnu hodnotu, musis zadat cele cislo z mnoziny <400,4000>"
        vstup = raw_input("Zadaj dlzku strany mapy (400 az 4000): ")

mnozstvo_kamenov = mnozstvo_kamenov*(velkost_mapy/100)
#spustenie serveru
herny_s.bind((host,port))
herny_s.settimeout(None)
herny_s.listen(5)
print "Server bol spusteny na porte:",port,"a na pocitaci:",ipcka_hosta
print "Cakam na hracov:",pocet_hracov,"/",pocet_hracov

#pripajanie hracov
while len(pripojenia) < pocet_hracov:
    zmena = False #Premenna do ktorej sa znaci ci sa niekto odpojil/pripojil
    try:
        tmp_p, tmp_a = herny_s.accept()
        herny_s.settimeout(None)
        pripojenia.append(tmp_p)
        adresy.append(tmp_a)
        #hlaska pre server
        print "Uspesne sa pripojil "+str(adresy[-1][0])
        print "Cakam na hracov:",pocet_hracov-len(pripojenia),"/",pocet_hracov
        #vypnutie tiemout-u pre klienta
        pripojenia[-1].settimeout(None)
        #hlaska pre klienta
        mySend(pripojenia[-1],("Uspesne si sa pripojil ku "+host+"\n"))
        zmena = True
    except socket.error:
        pass
    
    #kontrola staleho pripojenia hracov
    tmp = list(pripojenia)
    for i in xrange(len(pripojenia)):
        if mySend(pripojenia[i],"Si este stale pripojeny?") != None: #Toto znamena ze odoslanie prebehlo neuspesne
            tmp.pop(i)
            dcs = adresy.pop(i)
            print "Odpojil sa "+str(dcs[0])
            zmena = True
    pripojenia = list(tmp)
    if zmena:
        for i in pripojenia:
            mySend(i,("Caka sa na hracov: ")+str(pocet_hracov-len(pripojenia))+"/"+str(pocet_hracov))

#vypnutie timeout-u
herny_s.settimeout(None)
#po pripojeni hracov
#hlaska
print "Hra sa spusta s hracmi",adresy
#Generovanie terenu - Hlaska pre hracov
for i in pripojenia:
    try:
        mySend(i,"Generuje sa teren")
    except socket.timeout:
        pass
#Odoslanie velkosti mapy - socket.send() potrebuje string
for i in pripojenia:
    mySend(i,str(velkost_mapy))
    
mapa = generuj_prazdnu_mapu(velkost_mapy)

print "Zaklad mapy bol vytvoreny" #Vypise sa nech sa da vediet co server robi

#Generovanie struktur na mape
sprava = "" #vola sa to sprava lebo sa to bude posielat hracom
#vygeneruj kamene
for i in xrange(mnozstvo_kamenov):
    sprava += vygeneruj_kamen(randint(10,velkost_mapy-len(predloha_zakladne)),randint(10,velkost_mapy-len(predloha_zakladne)),randint(50,100))

print "Kamene boli rozmiestnene"    
#vygeneruj zakladne
#minimalna vzdialenost medzi zakladnami
min_vzdialenost = 50*velkost_mapy/200
#zakladne s poziciami (Rectami)
poloha_zakladnii = []
poloha_zakladnii_pre_tvorbu_mapy = []
for j in xrange(pocet_hracov):
    #vrchny lavy roh
    x = randint(20,velkost_mapy-len(predloha_zakladne)-10)
    y = randint(20,velkost_mapy-len(predloha_zakladne)-10)
    #je miesto volne? ak nie tak vygeneruj novu polohu
    je_volno = False
    tmp = Rect(0,0,2*min_vzdialenost+len(predloha_zakladne)*velkost_bloku,2*min_vzdialenost+len(predloha_zakladne)*velkost_bloku)
    tmp.center = [x*velkost_bloku+len(predloha_zakladne)*velkost_bloku/2,y*velkost_bloku+len(predloha_zakladne)*velkost_bloku/2]
    while not je_volno:
        je_volno = True
        if tmp.collidelistall(poloha_zakladnii_pre_tvorbu_mapy) != []:
            je_volno = False
        if not je_volno:
            x = randint(10,velkost_mapy-len(predloha_zakladne))
            y = randint(10,velkost_mapy-len(predloha_zakladne))
            tmp.center = [x*velkost_bloku+len(predloha_zakladne)*velkost_bloku/2,y*velkost_bloku+len(predloha_zakladne)*velkost_bloku/2]
            
    sprava += vytvor_zakladnu(x,y,j+1)
    poloha_zakladnii_pre_tvorbu_mapy.append(tmp)
    poloha_zakladnii.append([x*velkost_bloku,y*velkost_bloku])
    del tmp

print "Zakladne boli rozmiestnene"

#vypln vnutra kamenov... - Vypnute, lebo som to hlupo naprogramoval a strasne dlho trva kym to zbehne
#for z in range(10):
    #tmp = dokonci_kamene()                 #OPRAVIT!!!!!!!!
    #sprava += tmp
#print "Vnutra kamenov boli vyplnene"


uprav_mapu(sprava)

#posli hracom zmenene bloky
for i in pripojenia:
    mySend(i,sprava[:(len(sprava)/2)])
    mySend(i,sprava[(len(sprava)/2):])

print "Mapa bola uspesne vytvorena"

#Az teraz je potrebne vyuzit classy pre hracov - najprv sa do nich priradia ich sockety
hraci = []
for i in pripojenia:
    hraci.append(Hrac(i))

#Farby hracov - je ich 10
farby_hracov = ["Strednejarnezeleny","Zltohnedy","Indigovy","Olivovy","Tyrkysovy","Sedomodry","Cerveny","Modry","Zlty","Ruzovy"]
farby_hracov_na_ich_cisla = {"Modry":3,"Zlty":2,"Ruzovy":1,"Cerveny":4,"Sedomodry":5,"Tyrkysovy":6,"Olivovy":7,"Indigovy":8,
                             "Zltohnedy":9,"Strednejarnezeleny":10}


#Teraz rozmiestnime hracov do ich zakladnii
p = 0 #pomocna premenna
for i in hraci:
    i.x = poloha_zakladnii[p][0]+(len(predloha_zakladne)*velkost_bloku/2)-i.velkost/2
    i.y = poloha_zakladnii[p][1]+(len(predloha_zakladne)*velkost_bloku/2)-i.velkost/2-5
    #priradenie farby hracovi
    i.farba = farby_hracov.pop()
    #To 250 - x = to je kvoli tomu ze suradnice funguju inak v klientovi ako na serveri
    mySend(i.pripojenie,(str(250-i.x)+" "+str(250-i.y)+" "+i.farba))
    p += 1

#Oznam hracom ze su rozmiestneni
for i in hraci:
    mySend(i.pripojenie,str(pocet_hracov))

#Vylepsenia a ich ceny
vylepsenia_ceny = [20,30,30,40,300,200,400,400]
#Zatial su e. uspornost, max stity, baterie, utok, rychlopalba, emp strely, vybusne strely

#Odosielanie hracom ceny vyplepseni
sprava = ""
for i in vylepsenia_ceny:
    sprava += str(i)+" "
for i in hraci:
    mySend(i.pripojenie,sprava)

    
#hraci pripravte sa - sprava s odpocitavanim ------------------------------------------------------------------------------
for j in range(11):
    #odosielanie
    for i in hraci:
        try:
            mySend(i.pripojenie,("Hra sa zacne o "+str(10-j)))
        except socket.timeout:
            pass
    #cakanie
    #if (not debug_mode) and (not specialne_nastavenia):
        #time.sleep(1)
    
for i in hraci:
    mySend(i.pripojenie,"Start!")
    
#dokoncenie pripravy - tej pred initializaciou obrazovky u klientov


#posli hracom farby inych hracov   
sprava = ""
for i in hraci:
    for j in hraci:
        if not j == i:
            sprava += j.farba+" "
    mySend(i.pripojenie,sprava)
    sprava = ""

#zoznam striel
zoznam_striel = []
#zoznam antihmoty
zoznam_antihmoty = []
#zoznam diamantov
zoznam_diamantov = []
#zoznam vybuchujucich striel
zoznam_vybuchujucich_striel = []

#premenne    
cyklus = True
zmena_antihmoty = False
zmena_diamantov = False
upravene_bloky = ""

#experiment so snakami
if chcem_hada:
    had = [Snake(5,5)]

#samotna hra
while cyklus:
    #Odpojenie hracov ked prehraju - len test zatial
    #oznam im ci prehrali alebo nie
    for i in hraci:
        if i.stity < 0 or i.energia < 0:
            mySend(i.pripojenie,"Prehral si!")
        else:
            mySend(i.pripojenie,"")
            
    #zrus ich pripojenie
    for i in hraci:
        if (i.stity < 0 or i.energia < 0) and i.pripojenie != None:
            #Zrusenie socketu a odstranenie ho
            i.pripojenie.shutdown(socket.SHUT_RDWR) 
            i.pripojenie.close()
            i.pripojenie = None
            #oznacenie hraca ze prehral
            i.otocenie = 9

            #vypis ktory hrac a ako prehral
            if i.stity < 0:
                print i.farba,"tank bol zniceny!"
            if i.energia < 0:
                print i.farba,"tank si nedal pozor na energiu!"

            if i.nesie_antihmotu: #Zo zniceneho hraca vypadne antihmota
                i.nesie_antihmotu = False
                zoznam_antihmoty.append(Antihmota(i.x+7,i.y+7))
            
    #povedz hracom kde sa nachadzaju a ich otocenie + ci nesu antihmotu + kolko maju penazi
    for i in hraci:
        mySend(i.pripojenie,(str(250-i.x)+" "+str(250-i.y)+" "+str(i.otocenie)+" "+str(i.nesie_antihmotu)+" "+str(i.peniaze)))
    #povedz hracom kolko maju stitov a energie
    for i in hraci:
        mySend(i.pripojenie,(str(i.stity)+" "+str(i.energia)))
    #povedz hracom o inych hracoch (ich polohu a otocenie)
    sprava = ""
    for i in hraci:
        for j in hraci:
            if not j == i:
                sprava += str(j.x)+" "+str(j.y)+" "+str(j.otocenie)+" "+str(j.nesie_antihmotu)+":"
        mySend(i.pripojenie,sprava)
        sprava = ""

    #povedz hracom o strelach
    sprava = ""
    for i in zoznam_vybuchujucich_striel: #Oznami hracom o vybuchujucich strelach - len pre efektnost
        sprava += (str(i.x)+" "+str(i.y)+" "+str(i.otocenie)+" "+i.typ+":")
    for i in zoznam_striel:
        sprava += (str(i.x)+" "+str(i.y)+" "+str(i.otocenie)+" "+i.typ+":")
    for i in hraci:
        mySend(i.pripojenie,sprava)
        
    #povedz hracom o antihmote
    sprava = ""
    if zmena_antihmoty:
      for i in zoznam_antihmoty:
          if not i.nesena: #hraci nepotrebuju vediet o antihmote ktora je prave prenasana
              sprava += (str(i.stvorec.x)+" "+str(i.stvorec.y)+" "+str(i.vybuch)+" "+str(i.stabilita)+":")
    else:
      sprava = "Bez zmeny"
    for i in hraci:
        mySend(i.pripojenie,sprava)

    #povedz hracom o diamantoch
    sprava = ""
    if zmena_diamantov:
      for i in zoznam_diamantov:
          sprava += (str(i.stvorec.x)+" "+str(i.stvorec.y)+":")
    else:
      sprava = "Bez zmeny"
    for i in hraci:
        mySend(i.pripojenie,sprava)
    
    #premenne na zistenie ci treba poslat udaje o antihmote a diamantoch
    zmena_antihmoty = False
    zmena_diamantov = False

    #vymaz nesenu antihmotu
    tmp = list(zoznam_antihmoty)
    for i in xrange(len(zoznam_antihmoty)):
        if zoznam_antihmoty[i].nesena:
            try:
                tmp.pop(i)
                zmena_antihmoty = True
            except IndexError:
                pass
    zoznam_antihmoty = list(tmp)
    tmp = ""

    for i in zoznam_antihmoty:
        i.over_sa()

    #Vymaz zobrate diamanty
    tmp = list(zoznam_diamantov)
    for i in xrange(len(zoznam_diamantov)):
        #print zoznam_diamantov[i].zmaz_sa
        if zoznam_diamantov[i].zmaz_sa:
            try:
                tmp.pop(i)
                zmena_diamantov = True
            except IndexError:
                pass
    zoznam_diamantov = list(tmp)
    tmp = ""
        
    #Oznam hracom ktore bloky boli zmenene
    for i in hraci:
        mySend(i.pripojenie,upravene_bloky)

    #vymaz hracov ktory prehrali zo zoznamu
    tmp = list(hraci)
    for i in xrange(len(hraci)):
        if hraci[i].otocenie == 9:
            tmp.pop(i)

    hraci = list(tmp)
    tmp = ""

    #vypis ktory hrac vyhral
    if len(hraci) == 1 and not nevypisuj_kto_vyhral:
        print hraci[0].farba,"tank zvitazil!"
        nevypisuj_kto_vyhral = True
    
    #nieco tu este bude

    upravene_bloky = ""

    #vybuchy antihmoty
    for i in zoznam_antihmoty:
        if i.vybuch == True and i.stabilita == 0:
            #i.vybuch = False
            upravene_bloky += i.exploduj()
            zmena_antihmoty = True

    #pri vybuchoch sa musi poslat privela dat, preto sa proste nebudu posielat ale hraci si sami vyrataju kde ma byt aky blok
    uprav_mapu(upravene_bloky)
    upravene_bloky = ""

    #Umiestni na mapu dalsiu antihmotu ak jej nie je dost
    tmp = 0
    for i in zoznam_antihmoty: #Zistenie mnozstva antihmoty
        if i.stabilita < 0 and i.vybuch == False: #Zapocita sa len nova antihmota, ktorou hrac nehybal
            tmp += 1
        if i.vybuchuje or i.vybuch: #Ziadna nova antihmota sa nevygeneruje kym daka ina vybuchuje
            tmp += 10000

    pokusov = 0 #nech sa server nezasekne ak bude znicena vsetka hlina
    if tmp < velkost_mapy/pomer_antihmoty_ku_blokom: #na kazdych pomer_antihmoty_ku_blokom**2 blokov pripada 1 antihmota
        while pokusov < 5:
            x = randint(10,velkost_mapy*velkost_bloku-20)
            y = randint(10,velkost_mapy*velkost_bloku-20)
            volno = True
            for i in xrange(3):
                for j in xrange(2):
                    if not mapa[x/velkost_bloku+i][y/velkost_bloku+j] in [1,2]:
                        volno = False
            if volno:
                zoznam_antihmoty.append(Antihmota(x,y,-1))
                zmena_antihmoty = True
                break
            pokusov += 1


    #Vznik novych diamantov ak ich nie je dost
    pokusov = 0 #nech sa server nezasekne a nie je prilis pomaly
    if len(zoznam_diamantov) < velkost_mapy/pomer_diamantov_ku_blokom: #na kazdych pomer_diamatov_ku_blokom**2 blokov pripada 1 antihmota
        while pokusov < 50:
            x = randint(10,velkost_mapy*velkost_bloku-20)
            y = randint(10,velkost_mapy*velkost_bloku-20)
            volno = True
            for i in xrange(2):
                for j in xrange(4):
                    if not mapa[x/velkost_bloku+i][y/velkost_bloku+j] in [1,2]:
                        volno = False
            if volno:
                zoznam_diamantov.append(Diamant(x,y))
                zmena_diamantov = True
                break
            pokusov += 1
        
    
    #Precisti zoznam vybuchujucich striel
    tmp = list(zoznam_vybuchujucich_striel)
    for i in zoznam_vybuchujucich_striel:
        i.typ += "1"
        if "11111" in i.typ:
            tmp.remove(i)
    zoznam_vybuchujucich_striel = list(tmp)
    
    #Strely - vykona sa 2x
    for j in xrange(2):
        #Pohni strelami
        for i in zoznam_striel:
            upravene_bloky += i.pohyb()

        #Premaz strely
        tmp = list(zoznam_striel)
        for i in zoznam_striel:
            if "vymazana" in i.typ:
                if "explozivna" in i.typ:
                    zoznam_vybuchujucich_striel.append(i)
                tmp.remove(i)
        zoznam_striel = list(tmp)
    
    #spytaj sa hracov co chcu robit
    for i in hraci:
        #vo formate = pohyb (hore,dole...) : strielanie : specialne
        prikazy = (myRecv(i.pripojenie)).split(":")
        upravene_bloky += i.spracuj_prikazy(prikazy)

    #pohyb hadov
    if chcem_hada:
        for i in had:
            upravene_bloky += i.hyb_sa()
            had.append(i.rozmnoz_sa())
            try:
                had.remove("")
            except ValueError:
                pass
        #vymazanie mrtvych hadov
        tmp = list(had)
        for i in had:
            if i.zmaz_sa:
                for j in i.casti_tela:
                    upravene_bloky += str(j[0])+" "+str(j[1])+" 0:"
                tmp.remove(i)
        had = list(tmp)

    #uprav mapu podla prikazov hracov
    uprav_mapu(upravene_bloky)







    










