#!/usr/bin/python

#rozbiehanie programu
import pygame
import os
import platform
if platform.system() == 'Windows':
    os.environ['SDL_VIDEODRIVER'] = 'windib'
pygame.init()
from pygame import * #potrebne
from random import * #potrebne
from time import * #nie prilis potrebne
import numpy as np #potrebne
init()
#definicia farieb
black    = (   0,   0,   0)
white    = ( 255, 255, 255)
green    = (   0, 255,   0)
red      = ( 255,   0,   0)
blue     = (   0,   0, 255)
violet   = ( 128,   0, 127)
yellow   = ( 255, 255,   0)
travnik  = (   0, 214,   0)
hneda    = ( 166, 124,  35)
voda     = (  20, 154, 181)
siva = (131,136,138)

#classy
class Hrac():
    stvorec = 0

    #otocenie/natocenie
    otocenie = 0
    #obrazovka
    o = 0
    #pomocne
    size = []

    #energia a stity
    energia = 300
    stity = 20
    max_energia = 300
    max_stity = 200

    #farba
    farba = ""
    r_farba = []
    fb = Surface([35,35]) #farbiaci stvorec
    fbs = "" #farbiaci_stvorec_sikmo

    #antihmota
    nesie_antihmotu = False

    #Nakupy vylepseni
    peniaze = 0
    vylepsenia_max = [19,9,6,10,1,1,1,1] #Kolko vylepseni jedneho typu sa da naraz mat
    vylepsenia_level = [0,0,0,0,0,0,0,0] #Kolko vylepseni ktoreho typu hrac uz ma
    #Zatial su e. uspornost, max stity, baterie, utok, rychlopalba, emp strely, vybusne strely
    
    def __init__(self,o):
        self.stvorec = Rect(SCREEN_W/2,SCREEN_H/2,35,35)
        self.size = self.stvorec.size
        self.o = o

    def zafarbi_tank(self):
        self.fb.fill(self.r_farba)
        self.fb.set_alpha(100)
        self.fbs = transform.rotate(self.fb,45)
        #uprav farbiaci_stvorec_sikmo nech nema ruzove hrany
        tmp = self.fbs.get_width()/2
        draw.polygon(self.fbs,[0,0,0],[[0,0],[0,tmp],[tmp,0]])
        draw.polygon(self.fbs,[0,0,0],[[tmp,0],[tmp*2,0],[tmp*2,tmp]])
        draw.polygon(self.fbs,[0,0,0],[[0,tmp],[0,tmp*2],[tmp,tmp*2]])
        draw.polygon(self.fbs,[0,0,0],[[tmp,tmp*2],[tmp*2,tmp],[tmp*2,tmp*2]])
        self.fbs.set_colorkey([0,0,0,100])
    def nakresli(self):
        #specialna uprava vykreslovania nech sa spravne vykresluju veci ktore su sikmo
        offset = obrazky_tanku[self.otocenie].get_width()/2.0 - self.size[0]/2.0
        o.blit(obrazky_tanku[self.otocenie],[self.stvorec.x-offset,self.stvorec.y-offset])
        #zafarbenie tanku podla farby hraca
        if self.otocenie % 2 == 0:
            o.blit(self.fb,[self.stvorec.x-offset,self.stvorec.y-offset])
        else:
            o.blit(self.fbs,[self.stvorec.x-offset,self.stvorec.y-offset])
        if self.nesie_antihmotu:
            o.blit(antihmotove_prekrytie[self.otocenie],[self.stvorec.x-offset,self.stvorec.y-offset])
        

fb_zakladny = Surface([35,35]) #farbiaci stvorec
class Cudzi_hrac():
    #poloha
    x = 0
    y = 0
    #otocenie/natocenie
    otocenie = 0
    #obrazovka
    o = 0
    #pomocne
    size = []

    #farba
    farba = ""
    r_farba = []
    fb = "" #farbiaci stvorec
    fbs = "" #farbiaci_stvorec_sikmo

    #antihmota
    nesie_antihmotu = False
    
    def __init__(self,x,y,o):
        self.x = x
        self.y = y
        self.o = o
        self.size = [35,35]

    def zafarbi_tank(self):
        self.fb = fb_zakladny.copy()
        self.fb.fill(self.r_farba)
        self.fb.set_alpha(100)
        self.fbs = transform.rotate(self.fb,45)
        #uprav farbiaci_stvorec_sikmo nech nema ruzove hrany
        tmp = self.fbs.get_width()/2
        draw.polygon(self.fbs,[0,0,0],[[0,0],[0,tmp],[tmp,0]])
        draw.polygon(self.fbs,[0,0,0],[[tmp,0],[tmp*2,0],[tmp*2,tmp]])
        draw.polygon(self.fbs,[0,0,0],[[0,tmp],[0,tmp*2],[tmp,tmp*2]])
        draw.polygon(self.fbs,[0,0,0],[[tmp,tmp*2],[tmp*2,tmp],[tmp*2,tmp*2]])
        self.fbs.set_colorkey([0,0,0,100])
        
    def nakresli(self,kamera):
        if not self.otocenie >= 9: #tanky s otocenim 9 alebo viac su znicene a nemaju sa vykreslovat
            #specialna uprava vykreslovania nech sa spravne vykresluju veci ktore su sikmo
            offset = obrazky_tanku[self.otocenie].get_width()/2.0 - self.size[0]/2.0
            o.blit(obrazky_tanku[self.otocenie],[self.x+kamera.x-offset,self.y+kamera.y-offset])
            #zafarbenie tanku podla farby hraca
            if self.otocenie % 2 == 0:
                o.blit(self.fb,[self.x+kamera.x-offset,self.y+kamera.y-offset])
            else:
                o.blit(self.fbs,[self.x+kamera.x-offset,self.y+kamera.y-offset])
            if self.nesie_antihmotu:
                o.blit(antihmotove_prekrytie[self.otocenie],[self.x+kamera.x-offset,self.y+kamera.y-offset])

        
class Bonus():
    stvorec = 0
    #stena
    stena = False
    #obrazovka
    o = 0
    def __init__(self,x,y,w,h,o):
        self.stvorec = Rect(x,y,w,h)
        self.o = o

    def nakresli(self):
        draw.rect(self.o,yellow,self.stvorec)


#pre funkciu pod tymto - bloky s rovnakou farbou
neviditelne_bloky = [0,11,21,31,41,51,61,71,81,91,101] #nicota, regeneracne bloky
typ_bloku_na_farbu = {10:[255,127,255],20:[255,255,0],30:[0,0,255],40:[255,0,0],50:[0,128,128],
                      60:[64,224,208],70:[128,128,0],80:[75,0,130],90:[240,230,140],100:[0,255,127]}
#neznicitelne bloky - potrebne zadefinovat pre vybuchy
neznicitelne_bloky = [4]


def nakresli_blok(x,y,typ,kamera,velkost_bloku,obrazovka):
    farba = [255,0,255] #Ak sa ukaze tato farba, nieco je chybne
    if typ in neviditelne_bloky:
        farba = [0,0,0]
    elif typ == 1:
        farba = hneda
    elif typ == 2:
        farba = [hneda[0],hneda[1]+10,hneda[2]-20]
    elif typ == 3 or typ == 4:
        farba = siva
    elif typ % 10 == 0 and typ != 200:
        farba = typ_bloku_na_farbu[typ]
    x += kamera.x
    y += kamera.y
    if not farba == [0,0,0]:
        draw.rect(obrazovka,farba,[x,y,velkost_bloku,velkost_bloku])

#kamerove classy a funkcie
class Camera():
    #Zacina sa od tychto suradnic kvoli tomu ze okno ma rozmery 500x500 pixelov
    x = 250
    y = 250

def CameraCombineRect(stvorec,kamera):
    x = stvorec.x + kamera.x
    y = stvorec.y + kamera.y
    return Rect(x,y,stvorec.width,stvorec.height)

def CameraXYList(px,obrazovka_x,velkost_bloku,maximum):
    x = px/velkost_bloku
    x += 2
    xo = x*-1+(obrazovka_x)/velkost_bloku
    if x*-1 < 0:
        x = 0
    return x*-1,xo+4

#funkcia na upravovanie mapy podla prikazu(stringu)
def uprav_mapu(prikazy):
    if prikazy == "":
        return
    u_prikazy = [] #upravene prikazy
    u_prikazy = prikazy.split(":") #univerzalny oddelovac veci v sprave
    tmp = []
    for i in u_prikazy:
        tmp = i.split()
        if not tmp == []:
            try:
                if not (int(tmp[0]) < 0 or int(tmp[1]) < 0):
                    mapa[int(tmp[0])][int(tmp[1])] = int(tmp[2])
            except IndexError:
                pass

#funkcia na vykreslovanie striel
def nakresli_strelu(x,y,otocenie,typ,kamera):
    if typ == "obycajna":
        draw.rect(o,green,[x+kamera.x,y+kamera.y,velkost_bloku,velkost_bloku])
    elif "explozivna" in typ:
        draw.rect(o,[255, 165, 0],[x+kamera.x,y+kamera.y,velkost_bloku,velkost_bloku])
    elif "EMP" in typ:
        draw.rect(o,blue,[x+kamera.x,y+kamera.y,velkost_bloku,velkost_bloku])
    if "vymazana" in typ: #nakresli vybuch explozivnej strely
        draw.circle(o,red,[x+kamera.x+velkost_bloku/2,y+kamera.y+velkost_bloku/2],(5)*velkost_bloku)
        draw.circle(o,yellow,[x+kamera.x+velkost_bloku/2,y+kamera.y++velkost_bloku/2],(3)*velkost_bloku)
        draw.circle(o,blue,[x+kamera.x+velkost_bloku/2,y+kamera.y+velkost_bloku/2],(1)*velkost_bloku)

#funkcia na vykreslovanie antihmoty
faza_vybuchu_antihmoty = 0 #len pre efektnost vybuchu, pocita sa s tym ze bude naraz len jeden vybuch
def nakresli_antihmotu(x,y,vybuch,kamera):
    global faza_vybuchu_antihmoty
    if not vybuch:
        o.blit(obrazok_antihmoty,[x+kamera.x,y+kamera.y])
    else:
        if faza_vybuchu_antihmoty > 6:
            faza_vybuchu_antihmoty = 6
        draw.circle(o,red,[x+kamera.x+7,y+kamera.y+5],(faza_vybuchu_antihmoty*8+10)*velkost_bloku)
        draw.circle(o,yellow,[x+kamera.x+7,y+kamera.y+5],(faza_vybuchu_antihmoty*6+6)*velkost_bloku)
        draw.circle(o,blue,[x+kamera.x+7,y+kamera.y+5],(faza_vybuchu_antihmoty*3+2)*velkost_bloku)
        faza_vybuchu_antihmoty += 1
    #draw.rect(o,red,[x+kamera.x,y+kamera.y,velkost_bloku*3,velkost_bloku*2])

def exploduj_antihmotu(x,y): #Nicenie blokov pri vybuchu antihmoty - musi si to hrac sam vypocitat lebo prenos dat trva pridlho
    zvuk_vybuchu.play() #prehraj zvuk
    global faza_vybuchu_antihmoty
    r = 50*velkost_bloku #r ako polomer
    r2 = r**2 #r na druhu, potrebne pre zistenie ci je objekt vnutri vybuchu
    x1 = x+7
    y1 = y+5 #stred vybuchu

    #drobne premenne na znizenie zataze procesora
    x1_r_velkost_bloku = (x1-r)/velkost_bloku #(x1-r)/velkost_bloku = jednoduche ulozenie vysledku do premnnej
    y1_r_velkost_bloku = (y1-r)/velkost_bloku #(y1-r)/velkost_bloku = to iste co riadok vyssie len s Y

    #nicenie blokov
    zmenene_bloky = ""
    for i in range(r*2/velkost_bloku):
        i_velkost_bloku = i*velkost_bloku #Dalsi krok na znizenie zataze = Ulozenie i*velkost_bloku do premennej
        for j in range(r*2/velkost_bloku):
            j_velkost_bloku = j*velkost_bloku #Dalsi krok na znizenie zataze = Ulozenie j*velkost_bloku do premennej
            try:
                if not ((mapa[x1_r_velkost_bloku+i][y1_r_velkost_bloku+j] == 0) or x1_r_velkost_bloku+i < 0
                        or y1_r_velkost_bloku+j < 0):
                    if (((-r+i_velkost_bloku)**2)+((-r+j_velkost_bloku)**2)) <= r2:
                        if not mapa[x1_r_velkost_bloku+i][y1_r_velkost_bloku+j] in neznicitelne_bloky:
                            zmenene_bloky += str(x1_r_velkost_bloku+i) + " " + str(y1_r_velkost_bloku+j) + " 0:"
            except IndexError:
                pass

    if faza_vybuchu_antihmoty >= 6:
        faza_vybuchu_antihmoty = 0 #vynulovanie fazy vybuchu
    return zmenene_bloky

#funkcia na vykreslenie diamantov
def nakresli_diamant(x,y,kamera):
    #draw.rect(o,violet,[x+kamera.x,y+kamera.y,velkost_bloku,velkost_bloku])
    xk = x+kamera.x
    yk = y+kamera.y #rovno scitanie v premennynch, nech sa to lahsie pise
    draw.polygon(o,violet,[[xk+velkost_bloku,yk],[xk,yk+velkost_bloku*2],[xk+velkost_bloku,yk+velkost_bloku*4],[xk+velkost_bloku*2,yk+velkost_bloku*2]])

def generuj_prazdnu_mapu(velkost_mapy_funkcia): #u klienta tuto funkciu treb upravit nech ma teren striedave bloky
    #http://docs.scipy.org/doc/numpy-1.10.1/reference/generated/numpy.random.randint.html
    tmp_mapa = np.random.randint(1,3,(velkost_mapy_funkcia,velkost_mapy_funkcia))
    for i in xrange(velkost_mapy_funkcia):
        tmp_mapa[i][0] = 4
        tmp_mapa[0][i] = 4
        tmp_mapa[i][velkost_mapy_funkcia-1] = 4
        tmp_mapa[velkost_mapy_funkcia-1][i] = 4
    return tmp_mapa

#Koniec funkcii a classov

#importnutie mojich vlastnych kniznic
from sietova_kniznica import *

#pripajanie
import socket

#herny_socket = herny_s
herny_s = socket.socket()
herny_s.settimeout(None)
port = 8192
herny_s.setsockopt(socket.SOL_SOCKET,socket.SO_REUSEADDR,1)

#experimentalne na zrychlenie posielania a prijimania sprav
herny_s.setsockopt(socket.IPPROTO_TCP, socket.TCP_NODELAY, 1)

#pripojenie sa
pripojeny = False
while not pripojeny:
    host = raw_input("Zadaj adresu serveru: ")
    try:
        herny_s.connect((host, port))
        pripojeny = True
        print "Uspesne si sa pripojil"
    except socket.error as a:
        print a
        print "Ku serveru sa nepodarilo pripojit"
        print "Skontroluj zadanu adresu alebo stav serveru\n"


#cakanie na pripojenie vsetkych hracov
sprava = ""
while not sprava == "Generuje sa teren":
    sprava = ""
    sprava = myRecv(herny_s)
    if not sprava == "" and not sprava == "Si este stale pripojeny?":
        print sprava
        

#Urcenie velkosti mapy serverom - musi byt integer
mnozstvo_blokov_v_jednej_strane = int(myRecv(herny_s))

#tvorba mapy - zatial bude plna hliny
velkost_bloku = 5

mapa = generuj_prazdnu_mapu(mnozstvo_blokov_v_jednej_strane)
print "Zaklad mapy bol vygenerovany"


#Teraz server povie kde ma byt nieco specialne(napr. domceky)
#Uprava mapy podla servera
uprav_mapu(myRecv(herny_s)+myRecv(herny_s))

sprava = ""

#Vyroba kamery
kamera = Camera()
#Server rozhodne o pociatocnej pozicii hraca - pride vo formate string = x y 
sprava = (myRecv(herny_s)).split()
kamera.x = int(sprava[0])
kamera.y = int(sprava[1])
farba = sprava[2]


#Vypytame si pocet hracov od servera a vytvorime zoznam tychto inych hracov
pocet_hracov = int(myRecv(herny_s))
iny_hraci = []


#Tvorba textov s pouzitim fontu
print "Vytvaram texty"
#vybratie fontu
mojFont = font.Font(None,40)
mojFontPreHlavneSpravy = font.Font(None,100)
font_pre_ukazovatel_mnozstva_diamantov = font.Font(None,70)
texty = [mojFont.render("Stity",True,blue),mojFont.render("Energia",True,yellow),mojFontPreHlavneSpravy.render
         ("Prehral si!",True,red),mojFontPreHlavneSpravy.render("Vyhral si!",True,green)]
odpocet_text = []
for i in xrange(10):
    odpocet_text.append(mojFontPreHlavneSpravy.render(str(i),True,red))

#vytvor cislice pre ukazovatele mnozstva diamantov
text_pre_ukazovatel_mnozstva_diamatov = []
for i in xrange(10):
    text_pre_ukazovatel_mnozstva_diamatov.append(font_pre_ukazovatel_mnozstva_diamantov.render(str(i),True,yellow))

#Texty vylepseni
text_pre_vylepsenia = [mojFont.render("E. uspornost",True,blue),mojFont.render("Max stity",True,blue)
                        ,mojFont.render("Baterie",True,blue),mojFont.render("Utok",True,blue),mojFont.render("Rychlopalba",True,red),
                       mojFont.render("EMP strely",True,red),mojFont.render("Expl. strely",True,red),mojFont.render("Fazovac",True,red)]

text_pre_strany_obchodu = [mojFont.render("Dalsia",True,blue),mojFont.render("Predosla",True,blue)
                        ,mojFont.render("strana",True,blue)]


#INITIALIZACIA OBRAZOVKY!!!
velkost_obrazovky = (700,600)
#velkost_obrazovky = (0,0)
o = display.set_mode(velkost_obrazovky)

#Importovanie textur
print "Importujem obrazky"
obrazky_tanku = []
obrazok_antihmoty = ""

tank_trup = image.load("tank.png").convert_alpha()
tmp = tank_trup
for i in xrange(8):
    obrazky_tanku.append(transform.rotate(tmp,i*-45))
obrazok_antihmoty = image.load("antihmota.png").convert_alpha()

#prekrytie tanku, nech je vidiet ze nesie antihmotu
antihmotove_prekrytie = []
antihmotove_prekrytie.append(Surface((35,35),SRCALPHA,32))
antihmotove_prekrytie[0].convert_alpha()
antihmotove_prekrytie[0].blit(obrazok_antihmoty,[10,25])
for i in xrange(7):
    antihmotove_prekrytie.append(transform.rotate(antihmotove_prekrytie[0],(i+1)*-45))

#premenna pre ceny vylepseni - ziskaju sa ceny od servera
vylepsenia_ceny = []
#Zatial su e. uspornost, max stity, baterie, utok, rychlopalba, emp strely
tmp = myRecv(herny_s).split()
for i in tmp:
    vylepsenia_ceny.append(int(i))

strana_obchodu = 0 #Obchod s vylepseniami bude mat 2 strany 0. a 1.


#konecne spustanie s odpoctom
sprava = ""
tmp = 11
while not sprava == "Start!":
    tmp -= 1
    sprava = ""
    sprava = myRecv(herny_s)
    if not sprava == "":
        print sprava
    if not sprava == "Start!":
        o.fill(black)
        display.flip()



#velkost obrazovky na vykreslovanie mapy
SCREEN_W, SCREEN_H = o.get_size()
SCREEN_H -= 100
SCREEN_W -= 200
#Realna sa da ziskat z premennej velkost_obrazovky

display.set_caption("Tunneler - LAN")
o.fill(black)
display.update()
cyklus = True
hodiny = pygame.time.Clock()

#------------------
#farby text na RGB
farby_na_RGB = {"Zlty":[255,200,0],"Modry":[0,0,255],"Ruzovy":[255,125,255],"Cerveny":[255,0,0],"Sedomodry":[0,128,128],"Tyrkysovy":[64,224,208],
                "Olivovy":[128,128,0],"Indigovy":[75,0,130],"Zltohnedy":[240,230,140],"Strednejarnezeleny":[0,255,127]}
#vyroba hraca aj s farbou
hrac = Hrac(o)
hrac.farba = farba
hrac.r_farba = farby_na_RGB[hrac.farba]
hrac.zafarbi_tank()

#vyroba inych hracov - pocet_hracov sme ziskali vyssie v programe
for i in xrange(pocet_hracov-1): #pocet_hracov-1 kedze aj my sme jeden z hracov
    iny_hraci.append(Cudzi_hrac(0,0,o))

#priradovanie farieb hracom
sprava = (myRecv(herny_s)).split()
for i in iny_hraci:
    i.farba = sprava[0]
    i.r_farba = farby_na_RGB[i.farba]
    i.zafarbi_tank()
    sprava.pop(0)

#fps-zamok
hodiny = pygame.time.Clock()
maximalne_fps = 60

#premenne dalsie
prikazy = ""
sprava = ""
zoznam_antihmoty = []
zoznam_diamantov = []
zmen_fazu = 0 #na ovladanie fazovaca

#Zvuky - zatial len test
mixer.init()
zvuk_vybuchu = mixer.Sound("vybuch.ogg")

print "Nezatvaraj toto okno"
#samotna hra
while cyklus == True:
    #precistenie premennych
    prikazy = ""
    sprava = ""

    #zistime ci sme neprehrali
    if myRecv(herny_s) == "Prehral si!":
        print "Prehral si!"
        zvuk_vybuchu.play()
        draw.circle(o,red,[hrac.stvorec.centerx,hrac.stvorec.centery],(13)*velkost_bloku)
        draw.circle(o,yellow,[hrac.stvorec.centerx,hrac.stvorec.centery],(9)*velkost_bloku)
        draw.circle(o,blue,[hrac.stvorec.centerx,hrac.stvorec.centery],(4)*velkost_bloku)
        draw.rect(o,black,[98,SCREEN_H+18,4+hrac.max_stity,24])
        draw.rect(o,black,[138,SCREEN_H+58,4+hrac.max_energia,24])
        #Masivny text o prehre
        o.blit(texty[2],[20,20])
        display.flip()
        while cyklus == True:
            for udalost in event.get():
                if udalost.type == QUIT:
                    cyklus = False
                if udalost.type == KEYDOWN:
                    if udalost.key == K_ESCAPE:
                        cyklus = False
        break
    
    #Vypytame si od servera nasu polohu + otocenie
    sprava = (myRecv(herny_s)).split()
    kamera.x = int(sprava[0])
    kamera.y = int(sprava[1])
    if not int(sprava[2]) < 0:
        hrac.otocenie = int(sprava[2])
    hrac.nesie_antihmotu = sprava[3] == "True"
    hrac.peniaze = int(sprava[4])

    #Vypytame si od servera nase stity a energiu (V tomto poradi)
    sprava = (myRecv(herny_s)).split()
    hrac.stity = float(sprava[0])
    hrac.energia = float(sprava[1])

    #Vypytame si polohu a otocenie inych hracov
    sprava = (myRecv(herny_s)).split(":")
    tmp = ""
    for i in iny_hraci:
        if not i.otocenie > 9:
            tmp = (sprava.pop(0)).split()
            i.x = int(tmp[0])
            i.y = int(tmp[1])
            i.otocenie = int(tmp[2])
            i.nesie_antihmotu = tmp[3] == "True"

    #vypytame si polohu, otocenie a typ striel
    zoznam_striel = (myRecv(herny_s)).split(":")
    
    sprava = myRecv(herny_s)
    if not sprava == "Bez zmeny": #Ak sa nic noveho s antihmotou nestalo, nema zmysel menit ten zoznam
      zoznam_antihmoty = sprava.split(":") #ziskanie polohy antihmoty od serveru...
      
    sprava = myRecv(herny_s)
    if not sprava == "Bez zmeny": #Ak sa nic noveho s diamantami nestalo, nema zmysel menit ten zoznam
      zoznam_diamantov = sprava.split(":") #ziskanie polohy diamantov od serveru
      
    #Uprava mapy podla servera
    uprav_mapu(myRecv(herny_s))
    
    #Zbieranie stlaceni a takychto veci
    zoznam_udalosti = event.get()
    for udalost in event.get():
        if udalost.type == QUIT:
            cyklus = False
        if udalost.type == KEYDOWN:
            if udalost.key == K_ESCAPE:
                cyklus = False
    
    #input od hraca    
    keys = pygame.key.get_pressed()
    
    #zber prikazov pre server - pohyb
    
    if keys[pygame.K_a]:
        prikazy += "vlavo"
    elif keys[pygame.K_d]:
        prikazy += "vpravo"
    if keys[pygame.K_w]:
        prikazy += "hore"
    elif keys[pygame.K_s]:
        prikazy += "dole"
    if prikazy == "":
        prikazy = "nic"
        

    #strielanie
    if keys[pygame.K_SPACE]:
        prikazy += ":vystrel:"
    else:
        prikazy += ":nic:"

    if keys[pygame.K_q]:
        prikazy += "poloz:"
    elif keys[pygame.K_f] and zmen_fazu > 3:
        zmen_fazu = 0
        prikazy += "fazuj:" #zmena fazy - nove vylepsenie
    else:
        prikazy += ":"
    zmen_fazu += 1 #premenna na ovladanie fazovaca
        
    #vylepsenia
    for udalost in zoznam_udalosti:
        if udalost.type == KEYDOWN:
            if udalost.key == K_1:
                prikazy += "1"
            if udalost.key == K_2:
                prikazy += "2"
            if udalost.key == K_3:
                prikazy += "3"
            if udalost.key == K_4:
                prikazy += "4"
            if udalost.key == K_5:
                prikazy += "5"
                strana_obchodu = 1-strana_obchodu #Zmeni z 0 na 1 a z 1 na 0
            if udalost.key == K_ESCAPE:
                cyklus = False
            try:
                tmp = strana_obchodu * 4 #posun v zozname vylepseni
                if (hrac.peniaze >= vylepsenia_ceny[int(prikazy[-1])-1+tmp] and hrac.vylepsenia_max[int(prikazy[-1])-1+tmp] >
                hrac.vylepsenia_level[int(prikazy[-1])-1+tmp] and prikazy[-1] != "5"):
                    hrac.vylepsenia_level[int(prikazy[-1])-1+tmp] += 1
                    #Zaregistrovanie nakupu u hraca, nech server nemusi nic posielat
                    if int(prikazy[-1]) == 2 and strana_obchodu == 0:
                        hrac.max_stity += 40
                    if int(prikazy[-1]) == 3 and strana_obchodu == 0:
                        hrac.max_energia += 40
            except IndexError:
                pass
            except ValueError:
                pass
        if udalost.type == QUIT:
            cyklus = False
        
    #Kamera + zoznam
    zoz_x, zoz_xo = CameraXYList(kamera.x,SCREEN_W,velkost_bloku,mnozstvo_blokov_v_jednej_strane)
    zoz_y, zoz_yo = CameraXYList(kamera.y,SCREEN_H,velkost_bloku,mnozstvo_blokov_v_jednej_strane)

    
    #po zakladnych pohyboch...
    o.fill(black)
                
    #vykreslovanie blokov
    for i in xrange(zoz_x,len(mapa[zoz_x:zoz_xo])+zoz_x):
        for j in xrange(zoz_y,len(mapa[i][zoz_y:zoz_yo])+zoz_y):
            nakresli_blok(i*velkost_bloku,j*velkost_bloku,mapa[i][j],kamera,velkost_bloku,o)

    #vykreslenie antihmoty
    tmp = []
    for i in zoznam_antihmoty:
        if i.split() == []: #Istota je istota - vypne cyklus ak je premenna prazdna
            break
        tmp = i.split()
        nakresli_antihmotu(int(tmp[0]),int(tmp[1]),tmp[2]=="True",kamera)
        #vybuch antihmoty
        if int(tmp[3]) == 0:
            uprav_mapu(exploduj_antihmotu(int(tmp[0]),int(tmp[1])))

    #vykreslenie diamantov
    tmp = []
    for i in zoznam_diamantov:
        if i.split() == []: #Istota je istota - vypne cyklus ak je premenna prazdna
            break
        tmp = i.split()
        nakresli_diamant(int(tmp[0]),int(tmp[1]),kamera)
    
    hrac.nakresli()
    
    #vykreslenie inych hracov
    for i in iny_hraci:
        if not i.otocenie >= 9:
            i.nakresli(kamera)
        else: #nakresli efektny vybuch
            draw.circle(o,red,[i.x+kamera.x+17,i.y+kamera.y+17],13*velkost_bloku)
            draw.circle(o,yellow,[i.x+kamera.x+17,i.y+kamera.y+17],9*velkost_bloku)
            draw.circle(o,blue,[i.x+kamera.x+17,i.y+kamera.y+17],4*velkost_bloku)

    #odstran znicenych hracov zo zoznamu
    tmp = list(iny_hraci)
    for i in xrange(len(iny_hraci)):
        if iny_hraci[i].otocenie >= 9:
            iny_hraci[i].otocenie += 1
        if iny_hraci[i].otocenie == 15:
            tmp.pop(i)

    iny_hraci = list(tmp)
    tmp = ""

    #vykreslenie striel
    tmp = []
    for i in zoznam_striel:
        if i.split() == []: #Istota je istota - vypne cyklus ak je premenna prazdna
            break
        tmp = i.split()
        nakresli_strelu(int(tmp[0]),int(tmp[1]),int(tmp[2]),tmp[3],kamera)

    #Zafarbenie dodatocnych panelov (vylepsenia + stity)
    draw.rect(o,[136,139,140],[SCREEN_W,0,velkost_obrazovky[0]-SCREEN_W,SCREEN_H]) #zafarbenie plochy okolo hracej "obrazovky"
    draw.rect(o,[136,139,140],[0,SCREEN_H,velkost_obrazovky[0],velkost_obrazovky[1]-SCREEN_H]) #(zabrani zobrazovaniu sa hracov v nom)
    draw.rect(o,blue,[SCREEN_W,0,10,SCREEN_H])
    draw.rect(o,blue,[0,SCREEN_H,velkost_obrazovky[0],10]) #Oddelovace od hracej "obrazovky"

    #vypisanie vylepseni
    tmp = text_pre_ukazovatel_mnozstva_diamatov[0].get_width()
    try:
        for i in xrange(4):
            tmp3 = strana_obchodu*4 #ak je strana 1. nech hrac vidi dalsie 4 vylepsenia
            dcs = ((velkost_obrazovky[0]-(SCREEN_W+10))*(float(hrac.vylepsenia_level[i+tmp3])/float(hrac.vylepsenia_max[i+tmp3])))
            tmp2 = vylepsenia_ceny[i+tmp3]
            if hrac.vylepsenia_level[i+tmp3] > 0:
                draw.rect(o,green,[SCREEN_W+10,77+80*i,dcs,73])
            o.blit(text_pre_vylepsenia[i+tmp3],[SCREEN_W+20,80+80*i])
            if hrac.vylepsenia_max[i+tmp3] > hrac.vylepsenia_level[i+tmp3]: #ukazovanie ceny ak vylepsenie este nie je na maxe
                if not (tmp2%1000)/100 == 0:
                    o.blit(text_pre_ukazovatel_mnozstva_diamatov[(tmp2%1000)/100],[SCREEN_W+20+tmp,80+80*i+30])
                o.blit(text_pre_ukazovatel_mnozstva_diamatov[(tmp2%100)/10],[SCREEN_W+20+tmp*2,80+80*i+30])
                o.blit(text_pre_ukazovatel_mnozstva_diamatov[tmp2%10],[SCREEN_W+20+tmp*3,80+80*i+30])
            draw.line(o,black,[SCREEN_W+11,80+80*i+73],[velkost_obrazovky[0],80+80*i+73],5)
    except IndexError:
        pass

    #Vypis text pre zmenu strany pod vylepseniami - text_pre_strany_obchodu
    o.blit(text_pre_strany_obchodu[strana_obchodu],[SCREEN_W+20,420])
    o.blit(text_pre_strany_obchodu[2],[SCREEN_W+20,445])

    #Ukazovatel mnozstva diamantov - zlozitejsie nez sa zda
    draw.polygon(o,violet,[[SCREEN_W+50,10],[SCREEN_W+35,40],[SCREEN_W+50,70],[SCREEN_W+65,40]])
    #text_pre_ukazovatel_mnozstva_diamatov
    tmp = text_pre_ukazovatel_mnozstva_diamatov[0].get_width()
    o.blit(text_pre_ukazovatel_mnozstva_diamatov[hrac.peniaze%10],[SCREEN_W+75+2*tmp,20])
    o.blit(text_pre_ukazovatel_mnozstva_diamatov[(hrac.peniaze%100)/10],[SCREEN_W+75+tmp,20])
    o.blit(text_pre_ukazovatel_mnozstva_diamatov[(hrac.peniaze%1000)/100],[SCREEN_W+75,20])


    #Zvyraznenie ukazovatela energie a stitov
    draw.rect(o,black,[98,SCREEN_H+18,4+hrac.max_stity,24])
    draw.rect(o,black,[138,SCREEN_H+58,4+hrac.max_energia,24])
    
    
    #Zobrazenie energie a stitov
    o.blit(texty[0],[20,SCREEN_H+20])
    if not hrac.stity <= 0:
        draw.rect(o,blue,[100,SCREEN_H+20,hrac.stity,20])
    o.blit(texty[1],[20,SCREEN_H+60])
    if not hrac.energia <= 0:
        tmp = int(hrac.energia/2*(300.0/hrac.max_energia)) #vypocet na to nech funguju farbenie ukazatela
        draw.rect(o,[105+tmp,105+tmp,150-tmp],[140,SCREEN_H+60,hrac.energia,20])

    #Text ktory sa zobrazi ak hrac ostane posledny v hre
    if len(iny_hraci) == 0:
        o.blit(texty[3],[20,20])
    
    #Povedz serveru co chces urobit
    mySend(herny_s,prikazy)
    
        
    display.flip()
    hodiny.tick()#maximalne_fps)

try:
    herny_s.shutdown(socket.SHUT_RDWR)
    herny_s.close()
except socket.error:
    pass
quit()
